How can I print out all possible letter combinations a given phone number can represent?

前端 未结 30 2073
逝去的感伤
逝去的感伤 2020-12-22 18:01

I just tried for my first programming interview and one of the questions was to write a program that given a 7 digit telephone number, could print all possible combinations

相关标签:
30条回答
  • 2020-12-22 18:33

    This problem is similar to this leetcode problem. Here is the answer I submitted for this problem to leetcode (check github and video for explanation).

    So the very first thing we need is some way to hold the mappings of a digit and we can use a map for this:

    private Map<Integer, String> getDigitMap() {
            return Stream.of(
                    new AbstractMap.SimpleEntry<>(2, "abc"),
                    new AbstractMap.SimpleEntry<>(3, "def"),
                    new AbstractMap.SimpleEntry<>(4, "ghi"),
                    new AbstractMap.SimpleEntry<>(5, "jkl"),
                    new AbstractMap.SimpleEntry<>(6, "mno"),
                    new AbstractMap.SimpleEntry<>(7, "pqrs"),
                    new AbstractMap.SimpleEntry<>(8, "tuv"),
                    new AbstractMap.SimpleEntry<>(9, "wxyz"))
                   .collect(Collectors.toMap(AbstractMap.SimpleEntry::getKey, 
                                    AbstractMap.SimpleEntry::getValue));
    }
    

    The above method is preparing the map and next method I would use is to provide the mapping for provided digit:

    private String getDigitMappings(String strDigit, Map<Integer,String> digitMap) {
            int digit = Integer.valueOf(strDigit);
            return digitMap.containsKey(digit) ? digitMap.get(digit) : "";
    }
    

    This problem can be solved using backtracking and a backtracking solution generally has a structure where the method signature will contain: result container, temp results, original source with index etc. So the method structure would be of the form:

    private void compute(List<String> result, StringBuilder temp, String digits, int start, Map<Integer, String> digitMap) {
           // Condition to populate temp value to result
           // explore other arrangements based on the next input digit
           // Loop around the mappings of a digit and then to explore invoke the same method recursively
           // Also need to remove the digit which was in temp at last so as to get proper value in temp for next cycle in loop
    }
    

    And now the method body can be filled as (result will be kept in a list, temp in string builder etc.)

    private void compute(List<String> result, StringBuilder temp, String digits, int start, Map<Integer, String> digitMap) {
            if(start >= digits.length()) { // condition
                result.add(temp.toString());
                return;
            }
    
            String letters = getDigitMappings(digits.substring(start, start + 1), digitMap); // mappings of a digit to loop around
            for (int i = 0; i < letters.length(); i++) {
                temp.append(letters.charAt(i));
                compute(result, temp, digits, start+1, digitMap); //explore for remaining digits
                temp.deleteCharAt(temp.length() - 1); // remove last in temp
            }
    }
    

    And finally the method can be invoked as:

    public List<String> letterCombinations(String digits) {
            List<String> result = new ArrayList<>();
            if(digits == null || digits.length() == 0) return result;
            compute(result, new StringBuilder(), digits, 0, getDigitMap());
            return result;
    }
    

    Now the max mapped chars for a digit can be 4 (e.g. 9 has wxyz) and backtracking involves exhaustive search to explore all possible arrangements (state space tree) so for a digit of size n we are going to have 4x4x4....n times i.e. complexity would be O(4^n).

    0 讨论(0)
  • 2020-12-22 18:35

    A Python solution is quite economical, and because it uses generators is efficient in terms of memory use.

    import itertools
    
    keys = dict(enumerate('::ABC:DEF:GHI:JKL:MNO:PQRS:TUV:WXYZ'.split(':')))
    
    def words(number):
        digits = map(int, str(number))
        for ls in itertools.product(*map(keys.get, digits)):
            yield ''.join(ls)
    
    for w in words(258):
        print w
    

    Obviously itertools.product is solving most of the problem for you. But writing it oneself is not difficult. Here's a solution in go, which is careful to re-use the array result to generate all solutions in, and a closure f to capture the generated words. Combined, these give O(log n) memory use inside product.

    package main
    
    import (
        "bytes"
        "fmt"
        "strconv"
    )
    
    func product(choices [][]byte, result []byte, i int, f func([]byte)) {
        if i == len(result) {
            f(result)
            return
        }
        for _, c := range choices[i] {
            result[i] = c
            product(choices, result, i+1, f)
        }
    }
    
    var keys = bytes.Split([]byte("::ABC:DEF:GHI:JKL:MNO:PQRS:TUV:WXYZ"), []byte(":"))
    
    func words(num int, f func([]byte)) {
        ch := [][]byte{}
        for _, b := range strconv.Itoa(num) {
            ch = append(ch, keys[b-'0'])
        }
        product(ch, make([]byte, len(ch)), 0, f)
    }
    
    func main() {
        words(256, func(b []byte) { fmt.Println(string(b)) })
    }
    
    0 讨论(0)
  • 2020-12-22 18:35
    static final String[] keypad = {"", "", "ABC", "DEF", "GHI", "JKL", "MNO", "PQRS", "TUV", "WXYZ"};
    
    
    
    String[] printAlphabet(int num){
            if (num >= 0 && num < 10){
                String[] retStr;
                if (num == 0 || num ==1){
                    retStr = new String[]{""};
                } else {
                    retStr = new String[keypad[num].length()];
                    for (int i = 0 ; i < keypad[num].length(); i++){
                        retStr[i] = String.valueOf(keypad[num].charAt(i));
                    }
                }
                return retStr;
            }
    
            String[] nxtStr = printAlphabet(num/10);
    
            int digit = num % 10;
    
            String[] curStr = null;
            if(digit == 0 || digit == 1){
                curStr = new String[]{""};
            } else {
                curStr = new String[keypad[digit].length()];
                for (int i = 0; i < keypad[digit].length(); i++){
                    curStr[i] = String.valueOf(keypad[digit].charAt(i));
                }
            }
    
            String[] result = new String[curStr.length * nxtStr.length];
            int k=0;
    
            for (String cStr : curStr){
                for (String nStr : nxtStr){
                    result[k++] = nStr + cStr;
                }
            }
            return result;
        }
    
    0 讨论(0)
  • 2020-12-22 18:35

    You find source (Scala) here and an working applet here.

    Since 0 and 1 aren't matched to characters, they build natural breakpoints in numbers. But they don't occur in every number (except 0 at the beginning). Longer numbers like +49567892345 from 9 digits starting, can lead to OutOfMemoryErrors. So it would be better to split a number into groups like

    • 01723 5864
    • 0172 35864

    to see, if you can make sense from the shorter parts. I wrote such a program, and tested some numbers from my friends, but found rarely combinations of shorter words, which could be checked in a dictionary for matching, not to mention single, long words.

    So my decision was to only support searching, no full automation, by displaying possible combinations, encouraging splitting the number by hand, maybe multiple time.

    So I found +-RAD JUNG (+-bycicle boy).

    If you accept misspellings, abbreviations, foreign words, numbers as words, numbers in words, and names, your chance to find a solution is much better, than without fiddling around.

    246848 => 2hot4u (too hot for you) 
    466368 => goodn8 (good night) 
    1325   => 1FCK   (Football club)
    53517  => JDK17  (Java Developer Kit)
    

    are things a human might observe - to make an algorithm find such things is rather hard.

    0 讨论(0)
  • 2020-12-22 18:36

    The obvious solution is a function to map a digit to a list of keys, and then a function that would generate the possible combinations:

    The first is obvious, the second is more problematic because you have around 3^number of digits combinations, which can be a very large number.

    One way to do it is to look at each possibility for digit matching as a digit in a number (on base 4) and implement something close to a counter (jumping over some instances, since there are usually less than 4 letters mappable to a digit).

    The more obvious solutions would be nested loops or recursion, which are both less elegant, but in my opinion valid.

    Another thing for which care must be taken is to avoid scalability issues (e.g. keeping the possibilities in memory, etc.) since we are talking about a lot of combinations.

    P.S. Another interesting extension of the question would be localization.

    0 讨论(0)
  • 2020-12-22 18:36

    I tried it in ruby, and came up with a different way of doing, it's probably not efficient, like time and space O(?) at this point, but I like it because it uses Ruby's builtin Array.product method. What do you think?

    EDIT: I see a very similar solution in Python above, but I hadn't seen it when I added my answer

    def phone_to_abc(phone)
    
      phone_abc = [
        '0', '1', 'abc', 'def', 'ghi',
        'jkl', 'mno', 'pqrs', 'tuv', 'wxyz'
      ]
    
      phone_map = phone.chars.map { |x| phone_abc[x.to_i].chars }
      result = phone_map[0]
      for i in 1..phone_map.size-1
        result = result.product(phone_map[i])
      end
      result.each { |x|
        puts "#{x.join}"
      }
    
    end
    
    phone_to_abc('86352')
    
    0 讨论(0)
提交回复
热议问题